diff -ruN ../nakedmudv2.7/src/olc2/redit.c src/olc2/redit.c
--- ../nakedmudv2.7/src/olc2/redit.c	Sun Jul 31 17:13:51 2005
+++ src/olc2/redit.c	Fri Oct  7 14:15:55 2005
@@ -489,95 +576,513 @@
 
 
 //*****************************************************************************
+// room olc data
+//*****************************************************************************
+typedef struct {
+  char          *key; // the key for our prototype
+  char      *parents; // prototypes we inherit from
+  bool      abstract; // can we be loaded into the game?
+  bool    resettable; // do we reset when our zone resets?
+  ROOM_DATA    *room; // our room, which holds most of our variables
+  RESET_LIST *resets; // non-python reset rules
+  BUFFER *extra_code; // any extra code that should go into our prototype
+} ROOM_OLC;
+
+ROOM_OLC *newRoomOLC(void) {
+  ROOM_OLC *data   = malloc(sizeof(ROOM_OLC));
+  data->key        = strdup("");
+  data->parents    = strdup("");
+  data->room       = newRoom();
+  data->resets     = newResetList();
+  data->extra_code = newBuffer(1);
+  data->abstract   = TRUE;
+  data->resettable = FALSE;
+  roomSetTerrain(data->room, TERRAIN_NONE);
+  return data;
+}
+
+void deleteRoomOLC(ROOM_OLC *data) {
+  if(data->key)        free(data->key);
+  if(data->parents)    free(data->parents);
+  if(data->room)       deleteRoom(data->room);
+  if(data->resets)     deleteResetList(data->resets);
+  if(data->extra_code) deleteBuffer(data->extra_code);
+  free(data);
+}
+
+ROOM_DATA *roomOLCGetRoom(ROOM_OLC *data) {
+  return data->room;
+}
+
+RESET_LIST *roomOLCGetResets(ROOM_OLC *data) {
+  return data->resets;
+}
+
+const char *roomOLCGetKey(ROOM_OLC *data) {
+  return data->key;
+}
+
+const char *roomOLCGetParents(ROOM_OLC *data) {
+  return data->parents;
+}
+
+BUFFER *roomOLCGetExtraCode(ROOM_OLC *data) {
+  return data->extra_code;
+}
+
+bool roomOLCGetAbstract(ROOM_OLC *data) {
+  return data->abstract;
+}
+
+bool roomOLCGetResettable(ROOM_OLC *data) {
+  return data->resettable;
+}
+
+void roomOLCSetKey(ROOM_OLC *data, const char *key) {
+  if(data->key) free(data->key);
+  data->key =   strdupsafe(key);
+}
+
+void roomOLCSetParents(ROOM_OLC *data, const char *parents) {
+  if(data->parents) free(data->parents);
+  data->parents =   strdupsafe(parents);
+}
+
+void roomOLCSetAbstract(ROOM_OLC *data, bool abstract) {
+  data->abstract = abstract;
+}
+
+void roomOLCSetResettable(ROOM_OLC *data, bool resettable) {
+  data->resettable = resettable;
+}
+
+
+//
+// sets an exits values, based on a proto script
+void exit_from_proto(EXIT_DATA *exit, BUFFER *buf) {
+  char line[SMALL_BUFFER];
+  const char *code = bufferString(buf);
+
+  do {
+    char *lptr = line;
+    code = strcpyto(line, code, '\n');
+
+    if(!strcmp(lptr, "exit.makedoor()"))
+      exitSetClosable(exit, TRUE);
+    else if(!strncmp(lptr, "exit.name", 9)) {
+      while(*lptr != '\"') lptr++;
+      lptr++;                                  // kill the leading "
+      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill the ending "
+      exitSetName(exit, lptr);
+    }
+    else if(!strncmp(lptr, "exit.keywords", 13)) {
+      while(*lptr != '\"') lptr++;
+      lptr++;                                  // kill the leading "
+      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill the ending "
+      exitSetKeywords(exit, lptr);
+    }
+    else if(!strncmp(lptr, "exit.key", 8)) {
+      while(*lptr != '\"') lptr++;
+      lptr++;                                  // kill the leading "
+      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill the ending "
+      exitSetKey(exit, lptr);
+    }
+    else if(!strncmp(lptr, "exit.opposite", 13)) {
+      while(*lptr != '\"') lptr++;
+      lptr++;                                  // kill the leading "
+      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill the ending "
+      exitSetOpposite(exit, lptr);
+    }
+    else if(!strncmp(lptr, "exit.leave_mssg", 15)) {
+      while(*lptr != '\"') lptr++;
+      lptr++;                                  // kill the leading "
+      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill the ending "
+      exitSetSpecLeave(exit, lptr);
+    }
+    else if(!strncmp(lptr, "exit.enter_mssg", 15)) {
+      while(*lptr != '\"') lptr++;
+      lptr++;                                  // kill the leading "
+      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill the ending "
+      exitSetSpecEnter(exit, lptr);
+    }
+    else if(!strncmp(lptr, "exit.desc", 9)) {
+      while(*lptr != '\"') lptr++;
+      lptr++;                                  // kill the leading "
+      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill the ending "
+      exitSetDesc(exit, lptr);
+      bufferFormat(exitGetDescBuffer(exit), SCREEN_WIDTH, PARA_INDENT);
+    }
+    else if(!strncmp(lptr, "exit.pick_diff", 14)) {
+      while(!isdigit(*lptr)) lptr++;
+      exitSetPickLev(exit, atoi(lptr));
+    }
+    else if(!strncmp(lptr, "exit.spot_diff", 14)) {
+      while(!isdigit(*lptr)) lptr++;
+      exitSetHidden(exit, atoi(lptr));
+    }
+  } while(*code != '\0');
+}
+
+
+ROOM_OLC *roomOLCFromProto(PROTO_DATA *proto) {
+  ROOM_OLC  *data = newRoomOLC();
+  ROOM_DATA *room = roomOLCGetRoom(data);
+  roomOLCSetKey(data, protoGetKey(proto));
+  roomOLCSetParents(data, protoGetParents(proto));
+  roomOLCSetAbstract(data, protoIsAbstract(proto));
+
+  // this is a really ugly way to do the conversion, but basically let's
+  // just look through every line in the buffer and if we recognize some
+  // token, parse out whatever is assigned to it
+  char line[MAX_BUFFER];
+  const char *code = protoGetScript(proto);
+  do {
+    code = strcpyto(line, code, '\n');
+    char *lptr = line;
+    if(!strncmp(lptr, "me.name", 7)) {
+      while(*lptr != '\"') lptr++;
+      lptr++;                      // kill the leading "
+      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
+      roomSetName(room, lptr);
+    }
+    else if(!strncmp(lptr, "me.desc",  7)) {
+      // we have three "'s to skip by, because this lptr will take the form:
+      // me.desc = me.desc + " " + "..."
+      while(*lptr != '\"') lptr++; lptr++;
+      while(*lptr != '\"') lptr++; lptr++;
+      while(*lptr != '\"') lptr++; lptr++;
+      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
+      roomSetDesc(room, lptr);
+      bufferFormat(roomGetDescBuffer(room), SCREEN_WIDTH, PARA_INDENT);
+    }
+#ifdef MODULE_TIME
+    else if(!strncmp(lptr, "me.night_desc",  13)) {
+      // we have three "'s to skip by, because this lptr will take the form:
+      // me.desc = me.desc + " " + "..."
+      while(*lptr != '\"') lptr++; lptr++;
+      while(*lptr != '\"') lptr++; lptr++;
+      while(*lptr != '\"') lptr++; lptr++;
+      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
+      roomSetDesc(room, lptr);
+      bufferFormat(roomGetNightDescBuffer(room), SCREEN_WIDTH, PARA_INDENT);
+    }
+#endif
+    else if(!strncmp(lptr, "me.terrain", 10)) {
+      while(*lptr != '\"') lptr++;
+      lptr++;                      // kill the leading "
+      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
+      roomSetTerrain(room, terrainGetNum(lptr));
+    }
+    else if(!strncmp(lptr, "me.edesc(", 9)) {
+      while(*lptr != '\"') lptr++;
+      lptr++;                                              // kill the leading "
+      char *desc_start = lptr + next_letter_in(lptr, '\"') + 1;
+      lptr[next_letter_in(lptr, '\"')] = '\0';             // kill the ending "
+      while(*desc_start != '\"') desc_start++;
+      desc_start++;                                        // kill start and end
+      desc_start[next_letter_in(desc_start, '\"')] = '\0'; // "s for desc too
+      edescSetPut(roomGetEdescs(room), newEdesc(lptr, desc_start));
+    }
+    else if(!strncmp(lptr, "me.attach(\"", 11)) {
+      char trigname[SMALL_BUFFER];
+      sscanf(lptr, "me.attach(\"%s", trigname);
+      // kill our ending ")
+      trigname[strlen(trigname)-2] = '\0';
+      triggerListAdd(roomGetTriggers(room), trigname);
+    }
+    else if(!strncmp(lptr, "me.bits", 7)) {
+      while(*lptr != '\"') lptr++;
+      lptr++;                                  // kill the leading "
+      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill the ending "
+      bitSet(roomGetBits(room), lptr);
+    }
+
+    else if(!strncmp(lptr, "exit = me.dig(", 14)) {
+      while(*lptr != '\"') lptr++;
+      lptr++;                                              // kill the leading "
+      char *dest = lptr + next_letter_in(lptr, '\"') + 1;
+      lptr[next_letter_in(lptr, '\"')] = '\0';             // kill the ending "
+      while(*dest != '\"') dest++;
+      dest++;                                              // kill start and end
+      dest[next_letter_in(dest, '\"')] = '\0';             // "s for desc too
+      EXIT_DATA *exit = newExit();
+      exitSetTo(exit, dest);
+      roomSetExit(room, lptr, exit);
+
+      BUFFER *ex_buf = newBuffer(1);
+      code = strcpyto(line, code, '\n');
+      while(*line && strcmp(line, "### end exit") != 0) {
+	bprintf(ex_buf, "%s\n", line);
+	code = strcpyto(line, code, '\n');
+      }
+
+      exit_from_proto(exit, ex_buf);
+      deleteBuffer(ex_buf);
+    }
+
+    else if(!strcmp(lptr, "\n### begin extra code")) {
+      code = strcpyto(line, code, '\n');
+      while(*line && strcmp(line, "### end extra code") != 0) {
+	bprintf(roomOLCGetExtraCode(data), "%s\n", line);
+	code = strcpyto(line, code, '\n');
+      }
+    }
+  } while(*code != '\0');
+
+  return data;
+}
+
+
+//
+// Makes a python script out of an exit
+void exit_to_proto(EXIT_DATA *exit, BUFFER *buf) {
+  if(exitIsClosable(exit))
+    bprintf(buf, "exit.makedoor()\n");
+  if(*exitGetName(exit))
+    bprintf(buf, "exit.name       = \"%s\"\n", exitGetName(exit));
+  if(*exitGetKeywords(exit))
+    bprintf(buf, "exit.keywords   = \"%s\"\n", exitGetKeywords(exit));
+  if(*exitGetKey(exit))
+    bprintf(buf, "exit.key        = \"%s\"\n", exitGetKey(exit));
+  if(*exitGetOpposite(exit))
+    bprintf(buf, "exit.opposite   = \"%s\"\n", exitGetOpposite(exit));
+  if(*exitGetDesc(exit)) {
+    BUFFER *desc_copy = bufferCopy(exitGetDescBuffer(exit));
+    bufferReplace(desc_copy, "\n", " ", TRUE);
+    bufferReplace(desc_copy, "\r", "",  TRUE);
+    bprintf(buf, "exit.desc       = \"%s\"\n", bufferString(desc_copy));
+    deleteBuffer(desc_copy);
+  }
+  if(exitGetPickLev(exit) > 0)
+    bprintf(buf, "exit.pick_diff  = %d\n", exitGetPickLev(exit));
+  if(exitGetHidden(exit) > 0)
+    bprintf(buf, "exit.spot_diff  = %d\n", exitGetHidden(exit));
+  if(*exitGetSpecLeave(exit))
+    bprintf(buf, "exit.leave_mssg = \"%s\"\n", exitGetSpecLeave(exit));
+  if(*exitGetSpecEnter(exit))
+    bprintf(buf, "exit.enter_mssg = \"%s\"\n", exitGetSpecEnter(exit));
+}
+
+PROTO_DATA *roomOLCToProto(ROOM_OLC *data) {
+  PROTO_DATA *proto = newProto();
+  ROOM_DATA   *room = roomOLCGetRoom(data);
+  BUFFER       *buf = protoGetScriptBuffer(proto);
+  protoSetKey(proto, roomOLCGetKey(data));
+  protoSetParents(proto, roomOLCGetParents(data));
+  protoSetAbstract(proto, roomOLCGetAbstract(data));
+
+  bprintf(buf, "### The following rproto was generated by redit.\n");
+  bprintf(buf, "### If you edit this script, adhere to the stylistic\n"
+	       "### conventions laid out by redit, or delete the top line\n");
+
+  bprintf(buf, "\n### string values\n");
+  if(*roomGetName(room))
+    bprintf(buf, "me.name       = \"%s\"\n", roomGetName(room));
+  if(roomGetTerrain(room) != TERRAIN_NONE)
+    bprintf(buf, "me.terrain    = \"%s\"\n", 
+	    terrainGetName(roomGetTerrain(room)));
+  if(*roomGetDesc(room)) {
+    BUFFER *desc_copy = bufferCopy(roomGetDescBuffer(room));
+    bufferReplace(desc_copy, "\n", " ", TRUE);
+    bufferReplace(desc_copy, "\r", "",  TRUE);
+    bprintf(buf, "me.desc       = me.desc + \" \" + \"%s\"\n", 
+	    bufferString(desc_copy));
+    deleteBuffer(desc_copy);
+  }
+#ifdef MODULE_TIME
+  if(*roomGetNightDesc(room)) {
+    BUFFER *desc_copy = bufferCopy(roomGetNightDescBuffer(room));
+    bufferReplace(desc_copy, "\n", " ", TRUE);
+    bufferReplace(desc_copy, "\r", "",  TRUE);
+    bprintf(buf, "me.night_desc = me.night_desc + \" \" + \"%s\"\n", 
+	    bufferString(desc_copy));
+    deleteBuffer(desc_copy);
+  }
+#endif
+
+  // extra descriptions
+  if(listSize(edescSetGetList(roomGetEdescs(room))) > 0) {
+    bprintf(buf, "\n### extra descriptions\n");
+    LIST_ITERATOR *edesc_i= 
+      newListIterator(edescSetGetList(roomGetEdescs(room)));
+    EDESC_DATA      *edesc= NULL;
+    ITERATE_LIST(edesc, edesc_i) {
+      BUFFER *desc_copy = bufferCopy(edescGetDescBuffer(edesc));
+      bufferReplace(desc_copy, "\n", " ", TRUE);
+      bufferReplace(desc_copy, "\r", "",  TRUE);
+      bprintf(buf, "me.edesc(\"%s\", \"%s\")\n", 
+	      edescGetKeywords(edesc), bufferString(desc_copy));
+      deleteBuffer(desc_copy);
+    } deleteListIterator(edesc_i);
+  }
+
+  if(*bitvectorGetBits(roomGetBits(room))) {
+    bprintf(buf, "\n### room bits\n");
+    bprintf(buf, "me.bits     = \"%s\" + \", \" + me.bits\n", 
+	    bitvectorGetBits(roomGetBits(room)));
+  }
+
+  if(listSize(roomGetTriggers(room)) > 0) {
+    bprintf(buf, "\n### room triggers\n");
+    LIST_ITERATOR *trig_i = newListIterator(roomGetTriggers(room));
+    char            *trig = NULL;
+    ITERATE_LIST(trig, trig_i) {
+      bprintf(buf, "me.attach(\"%s\")\n", trig);
+    } deleteListIterator(trig_i);
+  }
+
+  // convert exits
+  LIST      *ex_names = roomGetExitNames(room);
+  LIST_ITERATOR *ex_i = newListIterator(ex_names);
+  char       *ex_name = NULL;
+  EXIT_DATA     *exit = NULL;
+  ITERATE_LIST(ex_name, ex_i) {
+    exit = roomGetExit(room, ex_name);
+    bprintf(buf, "\n### begin exit: %s\n", ex_name);
+    bprintf(buf, "exit = me.dig(\"%s\", \"%s\")\n", ex_name, exitGetTo(exit));
+    exit_to_proto(exit, buf);
+    bprintf(buf, "### end exit\n");
+  } deleteListIterator(ex_i);
+  deleteListWith(ex_names, free);
+
+  // extra code
+  if(bufferLength(roomOLCGetExtraCode(data)) > 0) {
+    bprintf(buf, "\n### begin extra code\n");
+    bprintf(buf, "%s", bufferString(roomOLCGetExtraCode(data)));
+    bprintf(buf, "### end extra code\n");
+  }
+
+  return proto;
+}
+
+
+
+//*****************************************************************************
 // room editing functions
 //*****************************************************************************
 
 // the different fields of a room we can edit
-#define REDIT_NAME       1
-#define REDIT_TERRAIN    2
-#define REDIT_EXIT       3
-#define REDIT_FILL_EXIT  4
-#define REDIT_BITVECTOR  5
+#define REDIT_PARENTS    2
+#define REDIT_NAME       3
+#define REDIT_TERRAIN    4
+#define REDIT_EXIT       5
+#define REDIT_FILL_EXIT  6
+#define REDIT_BITVECTOR  7
 
 
 //
 // Display the exits the socket can edit
 //
-void redit_exit_menu(SOCKET_DATA *sock, ROOM_DATA *room) {
-  int i;
+void redit_exit_menu(SOCKET_DATA *sock, ROOM_OLC *data) {
+  LIST       *ex_list = roomGetExitNames(roomOLCGetRoom(data));
+  LIST_ITERATOR *ex_i = newListIterator(ex_list);
+  char           *dir = NULL;
+  EXIT_DATA       *ex = NULL;
+  int               i = 0;
 
-  // normal exits first
+  // first, show all of the standard directions and display an entry for
+  // them, whether we have an exit or not
   for(i = 0; i < NUM_DIRS; i++) {
-    EXIT_DATA *exit = roomGetExit(room, i);
-    send_to_socket(sock, "   {g%-10s : {y[%s%6d{y]%s",
+    ex = roomGetExit(roomOLCGetRoom(data), dirGetName(i));
+    send_to_socket(sock, "   {g%-10s : %s%-20s%s",
 		   dirGetName(i), 
-		   (exit ? "{c" : "{y" ),
-		   (exit ? exitGetTo(exit) : -1),
-		   (!(i % 2) ? "   " : "\r\n"));
+		   (ex ? "{c" : "{y" ),
+		   (ex ? exitGetTo(ex) : "nowhere"),
+		   (!(i % 2) ? "   "   : "\r\n"));    
   }
 
-  // now special exits
-  int num_spec_exits = 0;
-  const char **room_names = roomGetExitNames(room, &num_spec_exits);
-  for(i = 0; i < num_spec_exits; i++) {
-    EXIT_DATA *exit = roomGetExitSpecial(room, room_names[i]);
-    send_to_socket(sock, "   {g%-10s : {y[{c%6d{y]%s",
-		   room_names[i],
-		   exitGetTo(exit),
-		   (!(i % 2) ? "   " : "\r\n"));
-  }
+  // now go through our exit list and do all of our special exits
+  i = 0;
+  ITERATE_LIST(dir, ex_i) {
+    if(dirGetNum(dir) == DIR_NONE) {
+      ex = roomGetExit(roomOLCGetRoom(data), dir);
+      send_to_socket(sock, "   {g%-10s : {c%s%s",
+		     dir, exitGetTo(ex),
+		     (!(i % 2) ? "   " : "\r\n"));
+      i++;
+    }
+  } deleteListIterator(ex_i);
+  deleteListWith(ex_list, free);
 
   // make sure we've printed the last newline if needed
   if(i % 2 == 1)
     send_to_socket(sock, "\r\n");
-
-  // clean up our mess
-  free(room_names);
 }
 
 
-void redit_menu(SOCKET_DATA *sock, ROOM_DATA *room) {
+void redit_menu(SOCKET_DATA *sock, ROOM_OLC *data) {
   send_to_socket(sock,
-		 "{y[{c%d{y]\r\n"
-		 "{g1) Name\r\n{c%s\r\n"
-		 "{g2) Description\r\n{c%s\r\n"
+		 "{y[{c%s{y]\r\n"
+		 "{g1) Abstract: {c%s\r\n"
+		 "{g2) Inherits from prototypes:\r\n"
+		 "{c%s\r\n"
+		 "{g3) Name\r\n{c%s\r\n"
+		 "{g4) Description\r\n{c%s"
 #ifdef MODULE_TIME
-		 "{g3) Night description (optional)\r\n{c%s\r\n"
+		 "{g5) Night description (optional)\r\n{c%s"
 #endif
+		 "{gL) Land type {y[{c%s{y]\r\n"
 		 "{gB) Set Bits: {c%s\r\n"
-		 "{gT) Terrain type {y[{c%s{y]\r\n"
-		 "{gX) Extra descriptions menu\r\n"
+		 "{gZ) Room can be reset: {c%s\r\n"
 		 "{gR) Room reset menu\r\n"
-		 "{gS) Script menu\r\n"
+		 "{gX) Extra descriptions menu\r\n"
+		 "{gT) Trigger menu\r\n"
 		 "{gE) Edit exit\r\n"
 		 "{gF) Fill exit\r\n"
 		 ,
-		 roomGetVnum(room), roomGetName(room), roomGetDesc(room),
+		 roomOLCGetKey(data), 
+		 (roomOLCGetAbstract(data) ? "yes" : "no"),
+		 roomOLCGetParents(data),
+		 roomGetName(roomOLCGetRoom(data)), 
+		 roomGetDesc(roomOLCGetRoom(data)),
 #ifdef MODULE_TIME
-		 roomGetNightDesc(room),
+		 roomGetNightDesc(roomOLCGetRoom(data)),
 #endif
-		 bitvectorGetBits(roomGetBits(room)),
-		 terrainGetName(roomGetTerrain(room)));
-  redit_exit_menu(sock, room);
+		 (roomGetTerrain(roomOLCGetRoom(data)) == TERRAIN_NONE ? 
+		  "leave unchanged" :
+		  terrainGetName(roomGetTerrain(roomOLCGetRoom(data)))),
+		 bitvectorGetBits(roomGetBits(roomOLCGetRoom(data))),
+		 (roomOLCGetResettable(data) ? "yes" : "no"));
+  redit_exit_menu(sock, data);
+
+  // only allow code editing for people with scripting priviledges
+  send_to_socket(sock, "\n{gC) Extra code%s\r\n", 
+		 ((!socketGetChar(sock) ||  
+		   !bitIsOneSet(charGetUserGroups(socketGetChar(sock)),
+				"scripter")) ? "    {y({cuneditable{y){g":""));
+  script_display(sock, bufferString(roomOLCGetExtraCode(data)), FALSE);
 }
 
 
-int redit_chooser(SOCKET_DATA *sock, ROOM_DATA *room, const char *option) {
+int redit_chooser(SOCKET_DATA *sock, ROOM_OLC *data, const char *option) {
   switch(toupper(*option)) {
   case '1':
+    roomOLCSetAbstract(data, (roomOLCGetAbstract(data) + 1) % 2);
+    return MENU_NOCHOICE;
+  case '2':
+    text_to_buffer(sock,"Enter comma-separated list of rooms to inherit from: ");
+    return REDIT_PARENTS;
+  case '3':
     text_to_buffer(sock, "Enter a new room name: ");
     return REDIT_NAME;
-  case '2':
+  case '4':
     text_to_buffer(sock, "Enter a new room description:\r\n");
-    socketStartEditor(sock, text_editor, roomGetDescBuffer(room));
+    socketStartEditor(sock, text_editor, roomGetDescBuffer(roomOLCGetRoom(data)));
     return MENU_NOCHOICE;
 #ifdef MODULE_TIME
-  case '3':
+  case '5':
     text_to_buffer(sock, "Enter a new night description:\r\n");
-    socketStartEditor(sock, text_editor, roomGetNightDescBuffer(room));
+    socketStartEditor(sock, text_editor, roomGetNightDescBuffer(roomOLCGetRoom(data)));
     return MENU_NOCHOICE;
 #endif
-  case 'T':
+  case 'Z':
+    roomOLCSetResettable(data, (roomOLCGetResettable(data) + 1) % 2);
+    return MENU_NOCHOICE;
+  case 'R':
+    do_olc(sock, rrledit_menu, rrledit_chooser, rrledit_parser, NULL, NULL,
+	   NULL, NULL, roomOLCGetResets(data));
+    return MENU_NOCHOICE;
+  case 'L':
     olc_display_table(sock, terrainGetName, NUM_TERRAINS, 3);
     text_to_buffer(sock, "Pick a terrain type: ");
     return REDIT_TERRAIN;
@@ -589,19 +1094,23 @@
     return REDIT_EXIT;
   case 'X':
     do_olc(sock, edesc_set_menu, edesc_set_chooser, edesc_set_parser, NULL,NULL,
-	   NULL, NULL, roomGetEdescs(room));
+	   NULL, NULL, roomGetEdescs(roomOLCGetRoom(data)));
     return MENU_NOCHOICE;
-  case 'R':
-    do_olc(sock, rrledit_menu, rrledit_chooser, rrledit_parser, 
-	   NULL, NULL, NULL, NULL, roomGetResets(room));
-    return MENU_NOCHOICE;
-  case 'S':
-    do_olc(sock, ssedit_menu, ssedit_chooser, ssedit_parser,
-	   NULL, NULL, NULL, NULL, roomGetScripts(room));
+  case 'T':
+    do_olc(sock, trigger_list_menu, trigger_list_chooser, trigger_list_parser,
+	   NULL, NULL, NULL, NULL, roomGetTriggers(roomOLCGetRoom(data)));
     return MENU_NOCHOICE;
   case 'B':
     do_olc(sock, bedit_menu, bedit_chooser, bedit_parser,
-	   NULL, NULL, NULL, NULL, roomGetBits(room));
+	   NULL, NULL, NULL, NULL, roomGetBits(roomOLCGetRoom(data)));
+    return MENU_NOCHOICE;
+  case 'C':
+    // only scripters can edit extra code
+    if(!socketGetChar(sock) || 
+       !bitIsOneSet(charGetUserGroups(socketGetChar(sock)), "scripter"))
+      return MENU_CHOICE_INVALID;
+    text_to_buffer(sock, "Edit extra code\r\n");
+    socketStartEditor(sock, script_editor, roomOLCGetExtraCode(data));
     return MENU_NOCHOICE;
   default:
     return MENU_CHOICE_INVALID;
@@ -609,46 +1118,67 @@
 }
 
 
-bool redit_parser(SOCKET_DATA *sock, ROOM_DATA *room, int choice, 
+bool redit_parser(SOCKET_DATA *sock, ROOM_OLC *data, int choice, 
 		  const char *arg) {
   switch(choice) {
+  case REDIT_PARENTS:
+    roomOLCSetParents(data, arg);
+    return TRUE;    
   case REDIT_NAME:
-    roomSetName(room, arg);
+    roomSetName(roomOLCGetRoom(data), arg);
     return TRUE;
   case REDIT_TERRAIN: {
     int val = atoi(arg);
     if(val < 0 || val >= NUM_TERRAINS)
       return FALSE;
-    roomSetTerrain(room, val);
+    roomSetTerrain(roomOLCGetRoom(data), val);
     return TRUE;
   }
   case REDIT_FILL_EXIT: {
-    int dir = dirGetNum(arg);
-    if(dir != DIR_NONE)
-      roomSetExit(room, dir, NULL);
-    else
-      roomSetExitSpecial(room, arg, NULL);
+    EXIT_DATA *old_exit = NULL;
+    const char     *dir = arg;
+    // are we trying to reference by its abbreviation?
+    if(!roomGetExit(roomOLCGetRoom(data), dir) && dirGetAbbrevNum(arg) != DIR_NONE)
+      dir = dirGetName(dirGetAbbrevNum(dir));
+    old_exit = roomRemoveExit(roomOLCGetRoom(data), dir);
+
+    // delete the exit...
+    if(old_exit != NULL) {
+      // is our room in the game? do we need to remove the exit from game?
+      if(propertyTableIn(room_table, roomGetUID(roomOLCGetRoom(data))))
+	exit_from_game(old_exit);
+      deleteExit(old_exit);
+    }
+
     return TRUE;
   }
 
   case REDIT_EXIT: {
-    EXIT_DATA *exit = NULL;
-    int dir = dirGetNum(arg);
-    // did we supply an arg?
     if(!*arg)
+      return FALSE;
+    else {
+      EXIT_DATA *exit = NULL;
+      const char *dir = arg;
+      
+      // are we trying to reference by its abbreviation?
+      if(!roomGetExit(roomOLCGetRoom(data), dir) && dirGetAbbrevNum(arg) != DIR_NONE)
+	dir = dirGetName(dirGetAbbrevNum(dir));
+      exit = roomGetExit(roomOLCGetRoom(data), dir);
+
+      // do we need to supply a new exit?
+      if(exit == NULL) {
+	exit = newExit();
+	// are we editing a room in game? If so, add this exit to the game
+	if(propertyTableIn(room_table, roomGetUID(roomOLCGetRoom(data))))
+	  exit_to_game(exit);
+	roomSetExit(roomOLCGetRoom(data), dir, exit);
+      }
+
+      // enter the exit editor
+      do_olc(sock, exedit_menu, exedit_chooser, exedit_parser, NULL, NULL,
+	     NULL, NULL, exit);
       return TRUE;
-    // find the exit. Create a new one if none exists
-    if(dir != DIR_NONE) {
-      if((exit = roomGetExit(room, dir)) == NULL)
-	roomSetExit(room, dir, (exit = newExit()));
-    }
-    else if((exit = roomGetExitSpecial(room, arg)) == NULL)
-      roomSetExitSpecial(room, arg, (exit = newExit()));
-
-    // enter the exit editor
-    do_olc(sock, exedit_menu, exedit_chooser, exedit_parser, NULL, NULL,
-	   NULL, NULL, exit);
-    return TRUE;
+    }
   }
     
   default:
@@ -656,49 +1186,165 @@
   }
 }
 
+void save_rreset(RESET_LIST *list) {
+  if(listSize(resetListGetResets(list)) > 0)
+    worldSaveType(gameworld, "reset", resetListGetKey(list));
+  else {
+    worldRemoveType(gameworld, "reset", resetListGetKey(list));
+    worldSaveType(gameworld, "reset", resetListGetKey(list));
+    deleteResetList(list);
+  }
+}
 
-// saves a room to disk
-void save_room(ROOM_DATA *room) {
-  worldSaveRoom(gameworld, room);
-  // also do some updating for the room if it is resettable
-  ZONE_DATA *zone = worldZoneBounding(gameworld, roomGetVnum(room));
-  if(roomIsResettable(room))
-    zoneAddResettableRoom(zone, roomGetVnum(room));
-  else
-    zoneRemoveResettableRoom(zone, roomGetVnum(room));
+void save_room_olc(ROOM_OLC *data) {
+  PROTO_DATA *old_proto = worldGetType(gameworld, "rproto",roomOLCGetKey(data));
+  PROTO_DATA *new_proto = roomOLCToProto(data);
+  RESET_LIST *old_reset = worldGetType(gameworld, "reset", roomOLCGetKey(data));
+  RESET_LIST *new_reset = roomOLCGetResets(data);
+  ZONE_DATA       *zone = 
+    worldGetZone(gameworld, get_key_locale(roomOLCGetKey(data)));
+
+  // save our room proto
+  if(old_proto == NULL)
+    worldPutType(gameworld, "rproto", protoGetKey(new_proto), new_proto);
+  else {
+    protoCopyTo(new_proto, old_proto);
+    deleteProto(new_proto);
+  }
+
+  // save our resets
+  if(old_reset == NULL && listSize(resetListGetResets(new_reset)) > 0)
+    worldPutType(gameworld, "reset", roomOLCGetKey(data), 
+		 resetListCopy(new_reset));
+  else if(old_reset != NULL)
+    resetListCopyTo(new_reset, old_reset);
+  else if(old_reset != NULL && listSize(resetListGetResets(new_reset)) == 0) {
+    worldRemoveType(gameworld, "reset", roomOLCGetKey(data));
+    deleteResetList(old_reset);
+  }
+
+  // check to see if we should reset this room even if it's not visited yet
+  if(roomOLCGetResettable(data) && 
+     !listGetWith(zoneGetResettable(zone),
+		  get_key_name(roomOLCGetKey(data)),
+		  strcasecmp))
+    listPut(zoneGetResettable(zone), strdup(get_key_name(roomOLCGetKey(data))));
+  else if(!roomOLCGetResettable(data)) {
+    char *found = listRemoveWith(zoneGetResettable(zone),
+				 get_key_name(roomOLCGetKey(data)),
+				 strcasecmp);
+    if(found) zoneSave(zone);
+  }
+
+  worldSaveType(gameworld, "rproto", roomOLCGetKey(data));
+  worldSaveType(gameworld, "reset",  roomOLCGetKey(data));
+  zoneSave(zone);
 }
 
 
-COMMAND(cmd_redit) {
-  ZONE_DATA *zone;
-  ROOM_DATA *room;
-  int vnum;
-
-  // if no argument is supplied, default to the current room
-  if(!arg || !*arg)
-    vnum = roomGetVnum(charGetRoom(ch));
-  else
-    vnum = atoi(arg);
-
-  // make sure there is a corresponding zone ...
-  if((zone = worldZoneBounding(gameworld, vnum)) == NULL)
-    send_to_char(ch, "No zone exists that contains the given vnum.\r\n");
+
+//*****************************************************************************
+// commands
+//*****************************************************************************
+COMMAND(cmd_resedit) {
+  ZONE_DATA    *zone = NULL;
+  RESET_LIST *resets = NULL;
+  const char   *rkey = arg;
+
+  // we need a key
+  if(!rkey || !*rkey)
+    rkey = roomGetClass(charGetRoom(ch));
+
+  char locale[SMALL_BUFFER];
+  char   name[SMALL_BUFFER];
+  if(!parse_worldkey_relative(ch, rkey, name, locale))
+    send_to_char(ch, "Which room are you trying to edit?\r\n");
+  // make sure we can edit the zone
+  else if((zone = worldGetZone(gameworld, locale)) == NULL)
+    send_to_char(ch, "No such zone exists.\r\n");
   else if(!canEditZone(zone, ch))
-    send_to_char(ch, "You are not authorized to edit this zone.\r\n");  
+    send_to_char(ch, "You are not authorized to edit that zone.\r\n");
   else {
-    // find the room
-    room = zoneGetRoom(zone, vnum);
-
-    // make our room
-    if(room == NULL) {
-      room = newRoom();
-      roomSetVnum(room, vnum);
-      roomSetName(room, "An Unfinished Room");
-      roomSetDesc(room, "   You are in an unfinished room.\r\n");
-      zoneAddRoom(zone, room);
+    // try to pull up the reset
+    resets = worldGetType(gameworld, "reset",  get_fullkey(name, locale));
+    
+    // if we don't already have a reset, make one
+    if(resets == NULL) {
+      resets = newResetList();
+      worldPutType(gameworld, "reset", get_fullkey(name, locale), resets);
     }
 
-    do_olc(charGetSocket(ch), redit_menu, redit_chooser, redit_parser,
-	   roomCopy, roomCopyTo, deleteRoom, save_room, room);
+    do_olc(charGetSocket(ch), rrledit_menu, rrledit_chooser, rrledit_parser, 
+	   resetListCopy, resetListCopyTo, deleteResetList, save_rreset, 
+	   resets);
+  }
+}
+
+
+COMMAND(cmd_redit) {
+  ZONE_DATA    *zone = NULL;
+  PROTO_DATA  *proto = NULL;
+  RESET_LIST *resets = NULL;
+  const char   *rkey = arg;
+
+  // we need a key
+  if(!rkey || !*rkey)
+    rkey = roomGetClass(charGetRoom(ch));
+
+  char locale[SMALL_BUFFER];
+  char   name[SMALL_BUFFER];
+  if(!parse_worldkey_relative(ch, rkey, name, locale))
+    send_to_char(ch, "Which room are you trying to edit?\r\n");
+  // make sure we can edit the zone
+  else if((zone = worldGetZone(gameworld, locale)) == NULL)
+    send_to_char(ch, "No such zone exists.\r\n");
+  else if(!canEditZone(zone, ch))
+    send_to_char(ch, "You are not authorized to edit that zone.\r\n");
+  else {
+    // try to make our OLC datastructure
+    ROOM_OLC *data = NULL;
+    
+    // try to pull up the prototype
+    proto  = worldGetType(gameworld, "rproto", get_fullkey(name, locale));
+    resets = worldGetType(gameworld, "reset",  get_fullkey(name, locale));
+
+    // if we already have proto data, try to parse an obj olc out of it
+    if(proto != NULL) {
+      // check to make sure the prototype was made by redit
+      char line[SMALL_BUFFER];
+      strcpyto(line, protoGetScript(proto), '\n');
+      if(strcmp(line, "### The following rproto was generated by redit.") != 0){
+	send_to_char(ch, "This room was not generated by redit and potential "
+		     "formatting problems prevent redit from being used. To "
+		     "edit, rpedit must be used.\r\n");
+	return;
+      }
+      else {
+	data = roomOLCFromProto(proto);
+	if(resets != NULL)
+	  resetListCopyTo(resets, roomOLCGetResets(data));
+	else
+	  resetListSetKey(roomOLCGetResets(data), get_fullkey(name, locale));
+      }
+    }
+    // otherwise, make a new obj olc and assign its key
+    else {
+      data = newRoomOLC();
+      roomOLCSetKey(data, get_fullkey(name, locale));
+      resetListSetKey(roomOLCGetResets(data), get_fullkey(name, locale));
+      roomOLCSetAbstract(data, TRUE);
+      
+      ROOM_DATA *room = roomOLCGetRoom(data);
+      roomSetName      (room, "an unfinished room");
+      roomSetDesc      (room, "it looks unfinished.\r\n");
+    }
+    
+    if(listGetWith(zoneGetResettable(zone), 
+		   get_key_name(roomOLCGetKey(data)),
+		   strcasecmp) != NULL)
+      roomOLCSetResettable(data, TRUE);
+    
+    do_olc(charGetSocket(ch), redit_menu, redit_chooser, redit_parser, 
+	   NULL, NULL, deleteRoomOLC, save_room_olc, data);
   }
 }
